# == Class: mysqlslave
#
# Full description of class mysqlslave here.
#
#This module deloy a Mysql Slave CloudStack instance with template Debian7. It's only work with the PHP/API script using Cloudstack Userdata parameters.
#
# The PHP/API script needed is available here : https://github.com/ikoula/cloudstack/blob/master/mysql-slave.php 
#
# === Authors
#
# Laurent H. Ikoula <contrib@ikoula.com>
#
# === Copyright
#
# Copyright 2013 Ikoula, unless otherwise noted.
#i

class mysql::install {
    package { "mysql-server":
        ensure => present,
        }
    file { "/etc/mysql/my.cnf" :
        replace  => "true",
        source => "/etc/puppet/modules/mysqlslave/files/etc.mysql.my.cnf",
        owner   => root,
        group   => root,
        require => Package['mysql-server'],
        mode    => 0644
    }
}
class mysql::passwd {
        exec { 'mysqlpasswd':
                command => 'mysqladmin -u root password `awk \'{print $1}\' /tmp/mysql`',
                path => '/usr/bin',
                require => Class["mysql::install"],
                logoutput => on_failure
        }
}
class mysql::slave {
    exec { 'mysqlslave':
        command => 'mysql -u root -p`awk \'{print $1}\' /tmp/mysql` -e "CHANGE MASTER TO MASTER_HOST = \'`awk \'{print $3}\' /tmp/mysql`\', MASTER_USER = \'replic_user\', MASTER_PASSWORD = \'`awk \'{print $2}\' /tmp/mysql`\', MASTER_PORT = 3306, MASTER_LOG_FILE = \'mysql-bin.000001\', MASTER_LOG_POS = 107;" && mysql -u root -p`awk \'{print $1}\' /tmp/mysql` -e "START SLAVE;" ; rm -f /tmp/mysql',
        path => ["/usr/bin", "/usr/sbin", "/bin", "/sbin"],
        require => [Class["mysql::install"],
                        Class["mysql::passwd"]
                        ]
        }
}
class mysql::service {
         case $::operatingsystem {
                'CentOS': {
                $mysql_service = 'mysqld'
                }
                'Fedora': {
                $mysql_service = 'mysqld'
                }
                'OpenSuSE': {
                $mysql_service = 'mysql'
                }
                'Debian': {
                $mysql_service = 'mysql'
                }
                'Ubuntu': {
                $mysql_service = 'mysql'
                }
                default: {
                $mysql_service  = 'mysql'
                }
        }
        #On s'assure que le service mysql est en cours d'exécution/activé :
        service { "$mysql_service" :
                        ensure     => running,
                        enable     => true,
                        hasrestart => true,
                        hasstatus => true,
                        require    => [ Class["mysql::install"],
                                        Class["mysql::slave"]
                                        ]
        }
        exec { 'mysqlrestart':
                command => '/etc/init.d/mysql restart',
        }
}
class mysqlslave {
        include mysql::install, mysql::passwd, mysql::slave, mysql::service
}
